--- old/./mr_sas_tbolt.c	Tue Nov  6 14:29:40 2012
+++ new/./mr_sas_tbolt.c	Tue Nov  6 14:29:40 2012
@@ -2052,16 +2059,17 @@
 
 		return (DDI_SUCCESS);
 	} else {
-		con_log(CL_ANN1, (CE_NOTE, "tbolt_issue_cmd_in_sync_mode: pushing the pkt\n"));
+		con_log(CL_ANN1, (CE_NOTE,
+		    "tbolt_issue_cmd_in_sync_mode: pushing the pkt"));
 		push_pending_mfi_pkt(instance, cmd);
 	}
 
 	con_log(CL_DLEVEL2, (CE_NOTE,
-	    "HighQport offset :%lx",
-	    (uint32_t *)((uintptr_t)(instance)->regmap + IB_HIGH_QPORT)));
+	    "HighQport offset :%p",
+	    (void *)((uintptr_t)(instance)->regmap + IB_HIGH_QPORT)));
 	con_log(CL_DLEVEL2, (CE_NOTE,
-	    "LowQport offset :%lx",
-	    (uint32_t *)((uintptr_t)(instance)->regmap + IB_LOW_QPORT)));
+	    "LowQport offset :%p",
+	    (void *)((uintptr_t)(instance)->regmap + IB_LOW_QPORT)));
 
 	cmd->sync_cmd = MRSAS_TRUE;
 	cmd->cmd_status =  ENODATA;
@@ -2073,9 +2081,9 @@
 	mutex_exit(&instance->reg_write_mtx);
 
 	con_log(CL_ANN1, (CE_NOTE,
-	    " req desc high part %x \n", (req_desc->Words >> 32)));
-	con_log(CL_ANN1, (CE_NOTE,
-	    " req desc low part %x \n", req_desc->Words));
+	    " req desc high part %x", (uint_t)(req_desc->Words >> 32)));
+	con_log(CL_ANN1, (CE_NOTE, " req desc low part %x",
+	    (uint_t)(req_desc->Words & 0xffffffff)));
 
 	mutex_enter(&instance->int_cmd_mtx);
 	for (i = 0; i < msecs && (cmd->cmd_status == ENODATA); i++) {
@@ -2103,8 +2111,10 @@
 	uint32_t	msecs = MFI_POLL_TIMEOUT_SECS * MILLISEC;
 	struct mrsas_header *frame_hdr;
 
-	con_log(CL_ANN, (CE_NOTE, "tbolt_issue_cmd_in_poll_mode: cmd->[SMID]=0x%X", cmd->SMID));
-	
+	con_log(CL_ANN,
+	    (CE_NOTE, "tbolt_issue_cmd_in_poll_mode: cmd->[SMID]=0x%X",
+	    cmd->SMID));
+
 	MRSAS_REQUEST_DESCRIPTOR_UNION *req_desc = cmd->request_desc;
 
 	frame_hdr = (struct mrsas_header *)&cmd->frame->hdr;
@@ -2111,13 +2121,13 @@
 	ddi_put8(cmd->frame_dma_obj.acc_handle, &frame_hdr->cmd_status,
 	    MFI_CMD_STATUS_POLL_MODE);
 	flags = ddi_get16(cmd->frame_dma_obj.acc_handle, &frame_hdr->flags);
-	flags 	|= MFI_FRAME_DONT_POST_IN_REPLY_QUEUE;
+	flags	|= MFI_FRAME_DONT_POST_IN_REPLY_QUEUE;
 	ddi_put16(cmd->frame_dma_obj.acc_handle, &frame_hdr->flags, flags);
 
+	con_log(CL_ANN1, (CE_NOTE, " req desc low part %x",
+	    (uint_t)(req_desc->Words & 0xffffffff)));
 	con_log(CL_ANN1, (CE_NOTE,
-	    " req desc low part %x \n", req_desc->Words));
-	con_log(CL_ANN1, (CE_NOTE,
-	    " req desc high part %x \n", (req_desc->Words >> 32)));
+	    " req desc high part %x", (uint_t)(req_desc->Words >> 32)));
 
 	/* issue the frame using inbound queue port */
 	mutex_enter(&instance->reg_write_mtx);
@@ -2135,7 +2145,7 @@
 	if (ddi_get8(cmd->frame_dma_obj.acc_handle,
 	    &frame_hdr->cmd_status) == MFI_CMD_STATUS_POLL_MODE) {
 		con_log(CL_ANN1, (CE_NOTE,
-		    " cmd failed %x \n", (req_desc->Words)));
+		    " cmd failed %" PRIx64, (req_desc->Words)));
 		return (DDI_FAILURE);
 	}
 
@@ -2145,16 +2155,14 @@
 void
 tbolt_enable_intr(struct mrsas_instance *instance)
 {
-	uint32_t	mask;
-
 	/* TODO: For Thunderbolt/Invader also clear intr on enable */
-	//writel(~0, &regs->outbound_intr_status);
-	//readl(&regs->outbound_intr_status);	
+	/* writel(~0, &regs->outbound_intr_status); */
+	/* readl(&regs->outbound_intr_status); */
 
 	WR_OB_INTR_MASK(~(MFI_FUSION_ENABLE_INTERRUPT_MASK), instance);
 
 	/* dummy read to force PCI flush */
-	mask = RD_OB_INTR_MASK(instance);
+	(void) RD_OB_INTR_MASK(instance);
 
 }
 
@@ -2162,14 +2170,12 @@
 tbolt_disable_intr(struct mrsas_instance *instance)
 {
 	uint32_t mask = 0xFFFFFFFF;
-	uint32_t status;
 
-
 	WR_OB_INTR_MASK(mask, instance);
 
 	/* Dummy readl to force pci flush */
 
-	status = RD_OB_INTR_MASK(instance);
+	(void) RD_OB_INTR_MASK(instance);
 }
 
 
@@ -2181,18 +2187,23 @@
 	/* check if it is our interrupt */
 	status = RD_OB_INTR_STATUS(instance);
 	con_log(CL_ANN1, (CE_NOTE,
-	    "chkpnt: Entered tbolt_intr_ack status = %d \n", status));
+	    "chkpnt: Entered tbolt_intr_ack status = %d", status));
 
 	if (!(status & MFI_FUSION_ENABLE_INTERRUPT_MASK)) {
 		return (DDI_INTR_UNCLAIMED);
 	}
 
+	if (mrsas_check_acc_handle(instance->regmap_handle) != DDI_SUCCESS) {
+		ddi_fm_service_impact(instance->dip, DDI_SERVICE_LOST);
+		return (DDI_INTR_UNCLAIMED);
+	}
+
 	if ((status & 1) || (status & MFI_FUSION_ENABLE_INTERRUPT_MASK)) {
 		/* clear the interrupt by writing back the same value */
 		WR_OB_INTR_STATUS(status, instance);
 		/* dummy READ */
-		RD_OB_INTR_STATUS(instance);
-		}
+		(void) RD_OB_INTR_STATUS(instance);
+	}
 	return (DDI_INTR_CLAIMED);
 }
 
@@ -2296,23 +2307,24 @@
 mr_sas_tbolt_build_mfi_cmd(struct mrsas_instance *instance,
     struct mrsas_cmd *cmd)
 {
-	Mpi2RaidSCSIIORequest_t 	*scsi_raid_io;
+	Mpi2RaidSCSIIORequest_t		*scsi_raid_io;
 	Mpi25IeeeSgeChain64_t		*scsi_raid_io_sgl_ieee;
-	MRSAS_REQUEST_DESCRIPTOR_UNION 	*ReqDescUnion;
+	MRSAS_REQUEST_DESCRIPTOR_UNION	*ReqDescUnion;
 	uint32_t			index;
+	ddi_acc_handle_t acc_handle =
+	    instance->mpi2_frame_pool_dma_obj.acc_handle;
 
 	if (!instance->tbolt) {
-		con_log(CL_ANN, (CE_NOTE, "Not MFA enabled.\n"));
+		con_log(CL_ANN, (CE_NOTE, "Not MFA enabled."));
 		return;
 	}
 
 	index = cmd->index;
 
-	ReqDescUnion =
-	    mr_sas_get_request_descriptor(instance, index, cmd);
+	ReqDescUnion = mr_sas_get_request_descriptor(instance, index);
 
 	if (!ReqDescUnion) {
-		con_log(CL_ANN1, (CE_NOTE, "[NULL REQDESC]%x"));
+		con_log(CL_ANN1, (CE_NOTE, "[NULL REQDESC]"));
 		return;
 	}
 
@@ -2328,30 +2340,26 @@
 
 	cmd->request_desc = ReqDescUnion;
 
-	// get raid message frame pointer
+	/* get raid message frame pointer */
 	scsi_raid_io = (Mpi2RaidSCSIIORequest_t *)cmd->scsi_io_request;
 
 	if (instance->device_id == PCI_DEVICE_ID_LSI_INVADER) {
-		Mpi25IeeeSgeChain64_t *sgl_ptr_end = (Mpi25IeeeSgeChain64_t *)&scsi_raid_io->SGL.IeeeChain;
+		Mpi25IeeeSgeChain64_t *sgl_ptr_end = (Mpi25IeeeSgeChain64_t *)
+		    &scsi_raid_io->SGL.IeeeChain;
 		sgl_ptr_end += instance->max_sge_in_main_msg - 1;
-		ddi_put8(instance->mpi2_frame_pool_dma_obj.acc_handle,
-		    &sgl_ptr_end->Flags, 0);
+		ddi_put8(acc_handle, &sgl_ptr_end->Flags, 0);
 	}
 
-	ddi_put8(instance->mpi2_frame_pool_dma_obj.acc_handle,
-	    &scsi_raid_io->Function,
+	ddi_put8(acc_handle, &scsi_raid_io->Function,
 	    MPI2_FUNCTION_PASSTHRU_IO_REQUEST);
 
-	ddi_put8(instance->mpi2_frame_pool_dma_obj.acc_handle,
-	    &scsi_raid_io->SGLOffset0,
+	ddi_put8(acc_handle, &scsi_raid_io->SGLOffset0,
 	    offsetof(MPI2_RAID_SCSI_IO_REQUEST, SGL) / 4);
 
-	ddi_put8(instance->mpi2_frame_pool_dma_obj.acc_handle,
-	    &scsi_raid_io->ChainOffset,
+	ddi_put8(acc_handle, &scsi_raid_io->ChainOffset,
 	    (U8)offsetof(MPI2_RAID_SCSI_IO_REQUEST, SGL) / 16);
 
-	ddi_put32(instance->mpi2_frame_pool_dma_obj.acc_handle,
-	    &scsi_raid_io->SenseBufferLowAddress,
+	ddi_put32(acc_handle, &scsi_raid_io->SenseBufferLowAddress,
 	    cmd->sense_phys_addr1);
 
 
@@ -2358,19 +2366,17 @@
 	scsi_raid_io_sgl_ieee =
 	    (Mpi25IeeeSgeChain64_t *)&scsi_raid_io->SGL.IeeeChain;
 
-	ddi_put64(instance->mpi2_frame_pool_dma_obj.acc_handle,
-	    &scsi_raid_io_sgl_ieee->Address,
+	ddi_put64(acc_handle, &scsi_raid_io_sgl_ieee->Address,
 	    (U64)cmd->frame_phys_addr);
 
-	ddi_put8(instance->mpi2_frame_pool_dma_obj.acc_handle,
-	    &scsi_raid_io_sgl_ieee->Flags,
-	    (IEEE_SGE_FLAGS_CHAIN_ELEMENT |
-                   MPI2_IEEE_SGE_FLAGS_IOCPLBNTA_ADDR));
-	ddi_put32(instance->mpi2_frame_pool_dma_obj.acc_handle,
-	    &scsi_raid_io_sgl_ieee->Length, 1024); //MEGASAS_MAX_SZ_CHAIN_FRAME
+	ddi_put8(acc_handle,
+	    &scsi_raid_io_sgl_ieee->Flags, (IEEE_SGE_FLAGS_CHAIN_ELEMENT |
+	    MPI2_IEEE_SGE_FLAGS_IOCPLBNTA_ADDR));
+	/* LSI put hardcoded 1024 instead of MEGASAS_MAX_SZ_CHAIN_FRAME. */
+	ddi_put32(acc_handle, &scsi_raid_io_sgl_ieee->Length, 1024);
 
 	con_log(CL_ANN1, (CE_NOTE,
-	    "[MFI CMD PHY ADDRESS]:%x",
+	    "[MFI CMD PHY ADDRESS]:%" PRIx64,
 	    scsi_raid_io_sgl_ieee->Address));
 	con_log(CL_ANN1, (CE_NOTE,
 	    "[SGL Length]:%x", scsi_raid_io_sgl_ieee->Length));
@@ -2390,15 +2396,14 @@
 	struct scsi_pkt			*pkt;
 	struct scsi_arq_status		*arqstat;
 	Mpi2RaidSCSIIORequest_t		*scsi_raid_io;
-	LD_LOAD_BALANCE_INFO 		*lbinfo;
-	int i;
+	LD_LOAD_BALANCE_INFO		*lbinfo;
+	ddi_acc_handle_t acc_handle =
+	    instance->mpi2_frame_pool_dma_obj.acc_handle;
 
 	scsi_raid_io = (Mpi2RaidSCSIIORequest_t *)cmd->scsi_io_request;
 
-	status = ddi_get8(instance->mpi2_frame_pool_dma_obj.acc_handle,
-	    &scsi_raid_io->RaidContext.status);
-	extStatus = ddi_get8(instance->mpi2_frame_pool_dma_obj.acc_handle,
-	    &scsi_raid_io->RaidContext.extStatus);
+	status = ddi_get8(acc_handle, &scsi_raid_io->RaidContext.status);
+	extStatus = ddi_get8(acc_handle, &scsi_raid_io->RaidContext.extStatus);
 
 	con_log(CL_DLEVEL3, (CE_NOTE, "status %x", status));
 	con_log(CL_DLEVEL3, (CE_NOTE, "extStatus %x", extStatus));
@@ -2413,243 +2418,242 @@
 
 	/* regular commands */
 
-	switch (ddi_get8(instance->mpi2_frame_pool_dma_obj.acc_handle,
-	    &scsi_raid_io->Function)) {
+	switch (ddi_get8(acc_handle, &scsi_raid_io->Function)) {
 
-		case MPI2_FUNCTION_SCSI_IO_REQUEST :  /* Fast Path IO. */
-			acmd =	(struct scsa_cmd *)cmd->cmd;
-			lbinfo = &instance->load_balance_info[acmd->device_id];
+	case MPI2_FUNCTION_SCSI_IO_REQUEST :  /* Fast Path IO. */
+		acmd =	(struct scsa_cmd *)cmd->cmd;
+		lbinfo = &instance->load_balance_info[acmd->device_id];
 
-			if (cmd->load_balance_flag & MEGASAS_LOAD_BALANCE_FLAG) {
-				arm = lbinfo->raid1DevHandle[0] == scsi_raid_io->DevHandle ? 0 : 1;
+		if (cmd->load_balance_flag & MEGASAS_LOAD_BALANCE_FLAG) {
+			arm = lbinfo->raid1DevHandle[0] ==
+			    scsi_raid_io->DevHandle ? 0 : 1;
 
-				lbinfo->scsi_pending_cmds[arm]--;
-				cmd->load_balance_flag &= ~MEGASAS_LOAD_BALANCE_FLAG;
-			}
-			con_log(CL_DLEVEL3, (CE_NOTE,
-			    "FastPath IO Completion Success "));
+			lbinfo->scsi_pending_cmds[arm]--;
+			cmd->load_balance_flag &= ~MEGASAS_LOAD_BALANCE_FLAG;
+		}
+		con_log(CL_DLEVEL3, (CE_NOTE,
+		    "FastPath IO Completion Success "));
+		/* FALLTHRU */
 
-		case MPI2_FUNCTION_LD_IO_REQUEST :   {// Regular Path IO.
-			acmd =	(struct scsa_cmd *)cmd->cmd;
-			pkt =	(struct scsi_pkt *)CMD2PKT(acmd);
+	case MPI2_FUNCTION_LD_IO_REQUEST :   { /* Regular Path IO. */
+		acmd =	(struct scsa_cmd *)cmd->cmd;
+		pkt =	(struct scsi_pkt *)CMD2PKT(acmd);
 
-			if (acmd->cmd_flags & CFLAG_DMAVALID) {
-				if (acmd->cmd_flags & CFLAG_CONSISTENT) {
-					(void) ddi_dma_sync(acmd->cmd_dmahandle,
-					    acmd->cmd_dma_offset,
-					    acmd->cmd_dma_len,
-					    DDI_DMA_SYNC_FORCPU);
-				}
+		if (acmd->cmd_flags & CFLAG_DMAVALID) {
+			if (acmd->cmd_flags & CFLAG_CONSISTENT) {
+				(void) ddi_dma_sync(acmd->cmd_dmahandle,
+				    acmd->cmd_dma_offset, acmd->cmd_dma_len,
+				    DDI_DMA_SYNC_FORCPU);
 			}
+		}
 
-			pkt->pkt_reason		= CMD_CMPLT;
-			pkt->pkt_statistics	= 0;
-			pkt->pkt_state = STATE_GOT_BUS
-			    | STATE_GOT_TARGET | STATE_SENT_CMD
-			    | STATE_XFERRED_DATA | STATE_GOT_STATUS;
+		pkt->pkt_reason		= CMD_CMPLT;
+		pkt->pkt_statistics	= 0;
+		pkt->pkt_state = STATE_GOT_BUS | STATE_GOT_TARGET |
+		    STATE_SENT_CMD | STATE_XFERRED_DATA | STATE_GOT_STATUS;
 
-			con_log(CL_ANN, (CE_CONT,
-			    " CDB[0] = %x completed for %s: size %lx SMID %x cmd_status %x",
-			    pkt->pkt_cdbp[0],
-			    ((acmd->islogical) ? "LD" : "PD"),
-			    acmd->cmd_dmacount, cmd->SMID, status));
+		con_log(CL_ANN, (CE_CONT, " CDB[0] = %x completed for %s: "
+		    "size %lx SMID %x cmd_status %x", pkt->pkt_cdbp[0],
+		    ((acmd->islogical) ? "LD" : "PD"),
+		    acmd->cmd_dmacount, cmd->SMID, status));
 
-			if (pkt->pkt_cdbp[0] == SCMD_INQUIRY) {
-				struct scsi_inquiry	*inq;
+		if (pkt->pkt_cdbp[0] == SCMD_INQUIRY) {
+			struct scsi_inquiry	*inq;
 
-				if (acmd->cmd_dmacount != 0) {
-					bp_mapin(acmd->cmd_buf);
-					inq = (struct scsi_inquiry *)
-					    acmd->cmd_buf->b_un.b_addr;
+			if (acmd->cmd_dmacount != 0) {
+				bp_mapin(acmd->cmd_buf);
+				inq = (struct scsi_inquiry *)
+				    acmd->cmd_buf->b_un.b_addr;
 
-					/* don't expose physical drives to OS */
-					if (acmd->islogical &&
-					    (status == MFI_STAT_OK)) {
-						display_scsi_inquiry(
-						    (caddr_t)inq);
-					} 
+				/* don't expose physical drives to OS */
+				if (acmd->islogical &&
+				    (status == MFI_STAT_OK)) {
+					display_scsi_inquiry((caddr_t)inq);
 #ifdef PDSUPPORT
-					else if ((status ==
-					    MFI_STAT_OK) && inq->inq_dtype ==
-					    DTYPE_DIRECT) {
-
-						display_scsi_inquiry(
-						    (caddr_t)inq);
-					}
+				} else if ((status == MFI_STAT_OK) &&
+				    inq->inq_dtype == DTYPE_DIRECT) {
+					display_scsi_inquiry((caddr_t)inq);
 #endif
-					else {
-						/* for physical disk */
-						status =
-						    MFI_STAT_DEVICE_NOT_FOUND;
-					}
+				} else {
+					/* for physical disk */
+					status = MFI_STAT_DEVICE_NOT_FOUND;
 				}
 			}
+		}
 
-			switch (status) {
-			case MFI_STAT_OK:
-				pkt->pkt_scbp[0] = STATUS_GOOD;
-				break;
-			case MFI_STAT_LD_CC_IN_PROGRESS:
-			case MFI_STAT_LD_RECON_IN_PROGRESS:
-				pkt->pkt_scbp[0] = STATUS_GOOD;
-				break;
-			case MFI_STAT_LD_INIT_IN_PROGRESS:
-				pkt->pkt_reason	= CMD_TRAN_ERR;
-				break;
-			case MFI_STAT_SCSI_IO_FAILED:
-				cmn_err(CE_WARN, "tbolt_complete_cmd: scsi_io failed");
-				pkt->pkt_reason	= CMD_TRAN_ERR;
-				break;
-			case MFI_STAT_SCSI_DONE_WITH_ERROR:
-				con_log(CL_ANN, (CE_WARN,
-					"tbolt_complete_cmd: scsi_done with error"));
+		switch (status) {
+		case MFI_STAT_OK:
+			pkt->pkt_scbp[0] = STATUS_GOOD;
+			break;
+		case MFI_STAT_LD_CC_IN_PROGRESS:
+		case MFI_STAT_LD_RECON_IN_PROGRESS:
+			pkt->pkt_scbp[0] = STATUS_GOOD;
+			break;
+		case MFI_STAT_LD_INIT_IN_PROGRESS:
+			pkt->pkt_reason	= CMD_TRAN_ERR;
+			break;
+		case MFI_STAT_SCSI_IO_FAILED:
+			cmn_err(CE_WARN, "tbolt_complete_cmd: scsi_io failed");
+			pkt->pkt_reason	= CMD_TRAN_ERR;
+			break;
+		case MFI_STAT_SCSI_DONE_WITH_ERROR:
+			con_log(CL_ANN, (CE_WARN,
+			    "tbolt_complete_cmd: scsi_done with error"));
 
-				pkt->pkt_reason	= CMD_CMPLT;
-				((struct scsi_status *)
-				    pkt->pkt_scbp)->sts_chk = 1;
+			pkt->pkt_reason	= CMD_CMPLT;
+			((struct scsi_status *)pkt->pkt_scbp)->sts_chk = 1;
 
-				if (pkt->pkt_cdbp[0] == SCMD_TEST_UNIT_READY) {
-					con_log(CL_ANN, (CE_WARN, "TEST_UNIT_READY fail"));
-				} else {
-					pkt->pkt_state |= STATE_ARQ_DONE;
-					arqstat = (void *)(pkt->pkt_scbp);
-					arqstat->sts_rqpkt_reason = CMD_CMPLT;
-					arqstat->sts_rqpkt_resid = 0;
-					arqstat->sts_rqpkt_state |=
-					    STATE_GOT_BUS | STATE_GOT_TARGET
-					    | STATE_SENT_CMD
-					    | STATE_XFERRED_DATA;
-					*(uint8_t *)&arqstat->sts_rqpkt_status =
-					    STATUS_GOOD;
-					con_log(CL_ANN1, (CE_NOTE,
-					    "Copying Sense data %x",
-					    cmd->SMID));
-
-					ddi_rep_get8(
-					    instance->
-					    mpi2_frame_pool_dma_obj.acc_handle,
-					    (uint8_t *)
-					    &(arqstat->sts_sensedata),
-					    cmd->sense1,
-					    sizeof (struct scsi_extended_sense),
-					    DDI_DEV_AUTOINCR);
-			
-				}
-				break;
-			case MFI_STAT_LD_OFFLINE:
-				cmn_err(CE_WARN,
-					"tbolt_complete_cmd: ld offline "
-					"CDB[0]=0x%x targetId=0x%x devhandle=0x%x\n",	//UNDO:
-					ddi_get8(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_raid_io->CDB.CDB32[0]),
-					ddi_get16(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_raid_io->RaidContext.ldTargetId),
-					ddi_get16(instance->mpi2_frame_pool_dma_obj.acc_handle, &scsi_raid_io->DevHandle) );
-				pkt->pkt_reason	= CMD_DEV_GONE;
-				pkt->pkt_statistics  = STAT_DISCON;
-				break;
-			case MFI_STAT_DEVICE_NOT_FOUND:
-			con_log(CL_ANN, (CE_CONT,
-				"tbolt_complete_cmd: device not found error"));
-				pkt->pkt_reason	= CMD_DEV_GONE;
-				pkt->pkt_statistics  = STAT_DISCON;
-				break;
-
-			case MFI_STAT_LD_LBA_OUT_OF_RANGE:
+			if (pkt->pkt_cdbp[0] == SCMD_TEST_UNIT_READY) {
+				con_log(CL_ANN,
+				    (CE_WARN, "TEST_UNIT_READY fail"));
+			} else {
 				pkt->pkt_state |= STATE_ARQ_DONE;
-				pkt->pkt_reason	= CMD_CMPLT;
-				((struct scsi_status *)
-				    pkt->pkt_scbp)->sts_chk = 1;
-
 				arqstat = (void *)(pkt->pkt_scbp);
 				arqstat->sts_rqpkt_reason = CMD_CMPLT;
 				arqstat->sts_rqpkt_resid = 0;
-				arqstat->sts_rqpkt_state |= STATE_GOT_BUS
-				    | STATE_GOT_TARGET | STATE_SENT_CMD
+				arqstat->sts_rqpkt_state |=
+				    STATE_GOT_BUS | STATE_GOT_TARGET
+				    | STATE_SENT_CMD
 				    | STATE_XFERRED_DATA;
 				*(uint8_t *)&arqstat->sts_rqpkt_status =
 				    STATUS_GOOD;
+				con_log(CL_ANN1,
+				    (CE_NOTE, "Copying Sense data %x",
+				    cmd->SMID));
 
-				arqstat->sts_sensedata.es_valid = 1;
-				arqstat->sts_sensedata.es_key =
-				    KEY_ILLEGAL_REQUEST;
-				arqstat->sts_sensedata.es_class =
-				    CLASS_EXTENDED_SENSE;
+				ddi_rep_get8(acc_handle,
+				    (uint8_t *)&(arqstat->sts_sensedata),
+				    cmd->sense1,
+				    sizeof (struct scsi_extended_sense),
+				    DDI_DEV_AUTOINCR);
 
-				/*
-				 * LOGICAL BLOCK ADDRESS OUT OF RANGE:
-				 * ASC: 0x21h; ASCQ: 0x00h;
-				 */
-				arqstat->sts_sensedata.es_add_code = 0x21;
-				arqstat->sts_sensedata.es_qual_code = 0x00;
-				break;
-			case MFI_STAT_INVALID_CMD:
-			case MFI_STAT_INVALID_DCMD:
-			case MFI_STAT_INVALID_PARAMETER:
-			case MFI_STAT_INVALID_SEQUENCE_NUMBER:
-			default:
-				cmn_err(CE_WARN, "tbolt_complete_cmd: Unknown status!");
-				pkt->pkt_reason	= CMD_TRAN_ERR;
-
-				break;
 			}
+			break;
+		case MFI_STAT_LD_OFFLINE:
+			cmn_err(CE_WARN,
+			    "tbolt_complete_cmd: ld offline "
+			    "CDB[0]=0x%x targetId=0x%x devhandle=0x%x",
+			    /* UNDO: */
+			    ddi_get8(acc_handle, &scsi_raid_io->CDB.CDB32[0]),
 
-			atomic_add_16(&instance->fw_outstanding, (-1));
+			    ddi_get16(acc_handle,
+			    &scsi_raid_io->RaidContext.ldTargetId),
 
-			/* Call the callback routine */
-			if (((pkt->pkt_flags & FLAG_NOINTR) == 0) &&
-			    pkt->pkt_comp) {
-				(*pkt->pkt_comp)(pkt);
-			}
+			    ddi_get16(acc_handle, &scsi_raid_io->DevHandle));
 
-			con_log(CL_ANN1, (CE_NOTE, "Free smid %x", cmd->SMID));
+			pkt->pkt_reason	= CMD_DEV_GONE;
+			pkt->pkt_statistics  = STAT_DISCON;
+			break;
+		case MFI_STAT_DEVICE_NOT_FOUND:
+			con_log(CL_ANN, (CE_CONT,
+			    "tbolt_complete_cmd: device not found error"));
+			pkt->pkt_reason	= CMD_DEV_GONE;
+			pkt->pkt_statistics  = STAT_DISCON;
+			break;
 
-			ddi_put8(instance->mpi2_frame_pool_dma_obj.acc_handle,
-			    &scsi_raid_io->RaidContext.status, 0);
+		case MFI_STAT_LD_LBA_OUT_OF_RANGE:
+			pkt->pkt_state |= STATE_ARQ_DONE;
+			pkt->pkt_reason	= CMD_CMPLT;
+			((struct scsi_status *)pkt->pkt_scbp)->sts_chk = 1;
 
-			ddi_put8(instance->mpi2_frame_pool_dma_obj.acc_handle,
-			    &scsi_raid_io->RaidContext.extStatus, 0);
+			arqstat = (void *)(pkt->pkt_scbp);
+			arqstat->sts_rqpkt_reason = CMD_CMPLT;
+			arqstat->sts_rqpkt_resid = 0;
+			arqstat->sts_rqpkt_state |= STATE_GOT_BUS
+			    | STATE_GOT_TARGET | STATE_SENT_CMD
+			    | STATE_XFERRED_DATA;
+			*(uint8_t *)&arqstat->sts_rqpkt_status = STATUS_GOOD;
 
-			return_raid_msg_pkt(instance, cmd);
+			arqstat->sts_sensedata.es_valid = 1;
+			arqstat->sts_sensedata.es_key = KEY_ILLEGAL_REQUEST;
+			arqstat->sts_sensedata.es_class = CLASS_EXTENDED_SENSE;
+
+			/*
+			 * LOGICAL BLOCK ADDRESS OUT OF RANGE:
+			 * ASC: 0x21h; ASCQ: 0x00h;
+			 */
+			arqstat->sts_sensedata.es_add_code = 0x21;
+			arqstat->sts_sensedata.es_qual_code = 0x00;
 			break;
+		case MFI_STAT_INVALID_CMD:
+		case MFI_STAT_INVALID_DCMD:
+		case MFI_STAT_INVALID_PARAMETER:
+		case MFI_STAT_INVALID_SEQUENCE_NUMBER:
+		default:
+			cmn_err(CE_WARN, "tbolt_complete_cmd: Unknown status!");
+			pkt->pkt_reason	= CMD_TRAN_ERR;
+
+			break;
 		}
-	case MPI2_FUNCTION_PASSTHRU_IO_REQUEST:  // MFA command.
 
-		if (cmd->frame->dcmd.opcode
-			 == MR_DCMD_LD_MAP_GET_INFO && 
-			 cmd->frame->dcmd.mbox.b[1] 
-			 == 1) {
-			
+		atomic_add_16(&instance->fw_outstanding, (-1));
+
+		(void) mrsas_common_check(instance, cmd);
+		if (acmd->cmd_dmahandle) {
+			if (mrsas_check_dma_handle(acmd->cmd_dmahandle) !=
+			    DDI_SUCCESS) {
+				ddi_fm_service_impact(instance->dip,
+				    DDI_SERVICE_UNAFFECTED);
+				pkt->pkt_reason = CMD_TRAN_ERR;
+				pkt->pkt_statistics = 0;
+			}
+		}
+
+		/* Call the callback routine */
+		if (((pkt->pkt_flags & FLAG_NOINTR) == 0) && pkt->pkt_comp)
+			(*pkt->pkt_comp)(pkt);
+
+		con_log(CL_ANN1, (CE_NOTE, "Free smid %x", cmd->SMID));
+
+		ddi_put8(acc_handle, &scsi_raid_io->RaidContext.status, 0);
+
+		ddi_put8(acc_handle, &scsi_raid_io->RaidContext.extStatus, 0);
+
+		return_raid_msg_pkt(instance, cmd);
+		break;
+	}
+	case MPI2_FUNCTION_PASSTHRU_IO_REQUEST:	 /* MFA command. */
+
+		if (cmd->frame->dcmd.opcode == MR_DCMD_LD_MAP_GET_INFO &&
+		    cmd->frame->dcmd.mbox.b[1] == 1) {
+
 			mutex_enter(&instance->sync_map_mtx);
 
 			con_log(CL_ANN, (CE_NOTE,
-                           "LDMAP sync command  SMID RECEIVED 0x%X",
-                           cmd->SMID));
+			    "LDMAP sync command	SMID RECEIVED 0x%X",
+			    cmd->SMID));
 			if (cmd->frame->hdr.cmd_status != 0) {
 				cmn_err(CE_WARN,
-			    		"map sync failed, status = 0x%x.\n",cmd->frame->hdr.cmd_status);
-			}
-			else {
+				    "map sync failed, status = 0x%x.",
+				    cmd->frame->hdr.cmd_status);
+			} else {
 				instance->map_id++;
 				cmn_err(CE_NOTE,
-			    		"map sync received, switched map_id to %ld \n",instance->map_id);
+				    "map sync received, switched map_id to %"
+				    PRIu64 " \n", instance->map_id);
 			}
 
-			if (MR_ValidateMapInfo(instance->ld_map[(instance->map_id & 1)], instance->load_balance_info))
-				instance->fast_path_io = 1; 
-			else 
-				instance->fast_path_io = 0;     
-			
+			if (MR_ValidateMapInfo(instance->ld_map[
+			    (instance->map_id & 1)],
+			    instance->load_balance_info)) {
+				instance->fast_path_io = 1;
+			} else {
+				instance->fast_path_io = 0;
+			}
+
 			con_log(CL_ANN, (CE_NOTE,
-		    		"instance->fast_path_io %d \n",instance->fast_path_io));
+			    "instance->fast_path_io %d",
+			    instance->fast_path_io));
 
 			instance->unroll.syncCmd = 0;
 
-			if(instance->map_update_cmd == cmd) {
+			if (instance->map_update_cmd == cmd) {
 				return_raid_msg_pkt(instance, cmd);
 				atomic_add_16(&instance->fw_outstanding, (-1));
-				mrsas_tbolt_sync_map_info(instance);
+				(void) mrsas_tbolt_sync_map_info(instance);
 			}
-	
-			cmn_err(CE_NOTE, "LDMAP sync completed.\n");
+
+			cmn_err(CE_NOTE, "LDMAP sync completed.");
 			mutex_exit(&instance->sync_map_mtx);
 			break;
 		}
@@ -2656,38 +2660,37 @@
 
 		if (cmd->frame->dcmd.opcode == MR_DCMD_CTRL_EVENT_WAIT) {
 			con_log(CL_ANN1, (CE_CONT,
-                           "AEN command SMID RECEIVED 0x%X",
-                           cmd->SMID));
-			 if ((instance->aen_cmd == cmd) &&
-                                    (instance->aen_cmd->abort_aen)) {
-                                        con_log(CL_ANN, (CE_WARN,
-                                            "mrsas_softintr: "
-                                            "aborted_aen returned"));
-			}
-			else
-			{
+			    "AEN command SMID RECEIVED 0x%X",
+			    cmd->SMID));
+			if ((instance->aen_cmd == cmd) &&
+			    (instance->aen_cmd->abort_aen)) {
+				con_log(CL_ANN, (CE_WARN, "mrsas_softintr: "
+				    "aborted_aen returned"));
+			} else {
 				atomic_add_16(&instance->fw_outstanding, (-1));
-                   service_mfi_aen(instance, cmd);
+				service_mfi_aen(instance, cmd);
 			}
 		}
 
-		if (cmd->sync_cmd == MRSAS_TRUE ) {
+		if (cmd->sync_cmd == MRSAS_TRUE) {
 			con_log(CL_ANN1, (CE_CONT,
-                           "Sync-mode Command Response SMID RECEIVED 0x%X",
-                           cmd->SMID));
+			    "Sync-mode Command Response SMID RECEIVED 0x%X",
+			    cmd->SMID));
 
 			tbolt_complete_cmd_in_sync_mode(instance, cmd);
-		}
-		else
-		{
+		} else {
 			con_log(CL_ANN, (CE_CONT,
-				"tbolt_complete_cmd: Wrong SMID RECEIVED 0x%X",
-                           	cmd->SMID));
+			    "tbolt_complete_cmd: Wrong SMID RECEIVED 0x%X",
+			    cmd->SMID));
 		}
 		break;
 	default:
+		mrsas_fm_ereport(instance, DDI_FM_DEVICE_NO_RESPONSE);
+		ddi_fm_service_impact(instance->dip, DDI_SERVICE_LOST);
+
 		/* free message */
-		con_log(CL_ANN, (CE_NOTE, "tbolt_complete_cmd: Unknown Type!!!!!!!!"));
+		con_log(CL_ANN,
+		    (CE_NOTE, "tbolt_complete_cmd: Unknown Type!!!!!!!!"));
 		break;
 	}
 }
@@ -2697,13 +2700,10 @@
 {
 	uint8_t				replyType;
 	Mpi2SCSIIOSuccessReplyDescriptor_t *replyDesc;
-	Mpi2ReplyDescriptorsUnion_t 	*desc;
+	Mpi2ReplyDescriptorsUnion_t	*desc;
 	uint16_t			smid;
-	union desc_value 		d_val;
+	union desc_value		d_val;
 	struct mrsas_cmd		*cmd;
-	uint32_t 			i;
-	Mpi2RaidSCSIIORequest_t		*scsi_raid_io;
-	uint8_t				status;
 
 	struct mrsas_header	*hdr;
 	struct scsi_pkt		*pkt;
@@ -2724,60 +2724,69 @@
 	if (replyType == MPI2_RPY_DESCRIPT_FLAGS_UNUSED)
 		return (DDI_INTR_UNCLAIMED);
 
-	con_log(CL_ANN1, (CE_NOTE, "Reply Desc  = %llx  Words = %llx \n",
-				desc, desc->Words));
+	if (mrsas_check_dma_handle(instance->mfi_internal_dma_obj.dma_handle)
+	    != DDI_SUCCESS) {
+		mrsas_fm_ereport(instance, DDI_FM_DEVICE_NO_RESPONSE);
+		ddi_fm_service_impact(instance->dip, DDI_SERVICE_LOST);
+		con_log(CL_ANN1,
+		    (CE_WARN, "mr_sas_tbolt_process_outstanding_cmd(): "
+		    "FMA check, returning DDI_INTR_UNCLAIMED"));
+		return (DDI_INTR_CLAIMED);
+	}
 
+	con_log(CL_ANN1, (CE_NOTE, "Reply Desc	= %p  Words = %" PRIx64,
+	    (void *)desc, desc->Words));
+
 	d_val.word = desc->Words;
-	
 
+
 	/* Read Reply descriptor */
 	while ((d_val.u1.low != 0xffffffff) &&
 	    (d_val.u1.high != 0xffffffff)) {
 
 		(void) ddi_dma_sync(instance->reply_desc_dma_obj.dma_handle,
-	    	0, 0, DDI_DMA_SYNC_FORCPU);
+		    0, 0, DDI_DMA_SYNC_FORCPU);
 
 		smid = replyDesc->SMID;
 
 		if (!smid || smid > instance->max_fw_cmds + 1) {
 			con_log(CL_ANN1, (CE_NOTE,
-			    "Reply Desc at Break  = %llx  Words = %llx \n",
-			    desc, desc->Words));
+			    "Reply Desc at Break  = %p	Words = %" PRIx64,
+			    (void *)desc, desc->Words));
 			break;
 		}
 
 		cmd	= instance->cmd_list[smid - 1];
-		if(!cmd ) {
-	  		con_log(CL_ANN1, (CE_NOTE,
-				"mr_sas_tbolt_process_outstanding_cmd: Invalid command "
-				" or Poll commad Received in completion path\n"));
-		}
-		else {
+		if (!cmd) {
+			con_log(CL_ANN1, (CE_NOTE, "mr_sas_tbolt_process_"
+			    "outstanding_cmd: Invalid command "
+			    " or Poll commad Received in completion path"));
+		} else {
 			mutex_enter(&instance->cmd_pend_mtx);
 			if (cmd->sync_cmd == MRSAS_TRUE) {
 				hdr = (struct mrsas_header *)&cmd->frame->hdr;
 				if (hdr) {
-	  				con_log(CL_ANN1, (CE_NOTE,
-						"mr_sas_tbolt_process_outstanding_cmd:"
-						" mlist_del_init(&cmd->list).\n"));
+					con_log(CL_ANN1, (CE_NOTE, "mr_sas_"
+					    "tbolt_process_outstanding_cmd:"
+					    " mlist_del_init(&cmd->list)."));
 					mlist_del_init(&cmd->list);
 				}
-				} else {
-					pkt = cmd->pkt;
-					if (pkt) {
-	  					con_log(CL_ANN1, (CE_NOTE,
-							"mr_sas_tbolt_process_outstanding_cmd:"
-							"mlist_del_init(&cmd->list).\n"));
+			} else {
+				pkt = cmd->pkt;
+				if (pkt) {
+					con_log(CL_ANN1, (CE_NOTE, "mr_sas_"
+					    "tbolt_process_outstanding_cmd:"
+					    "mlist_del_init(&cmd->list)."));
 					mlist_del_init(&cmd->list);
 				}
 			}
 
 			mutex_exit(&instance->cmd_pend_mtx);
-			
+
 			tbolt_complete_cmd(instance, cmd);
-		}	
-		// set it back to all 0xfffffffff.
-		desc->Words = (uint64_t)~0;
+		}
+		/* set it back to all 1s. */
+		desc->Words = -1LL;
 
 		instance->reply_read_index++;
 
@@ -2797,8 +2806,8 @@
 		d_val.word = desc->Words;
 
 		con_log(CL_ANN1, (CE_NOTE,
-		    "Next Reply Desc  = %llx Words = %llx\n",
-		    desc, desc->Words));
+		    "Next Reply Desc  = %p Words = %" PRIx64,
+		    (void *)desc, desc->Words));
 
 		replyType = replyDesc->ReplyFlags &
 		    MPI2_RPY_DESCRIPT_FLAGS_TYPE_MASK;
@@ -2852,7 +2861,7 @@
 }
 
 /*
- * mrsas_tbolt_get_ld_map_info -	Returns  ld_map structure
+ * mrsas_tbolt_get_ld_map_info -	Returns	 ld_map structure
  * instance:				Adapter soft state
  *
  * Issues an internal command (DCMD) to get the FW's controller PD
@@ -2890,14 +2899,13 @@
 	ci_h = instance->ld_map_phy[(instance->map_id & 1)];
 
 	if (!ci) {
-		cmn_err(CE_WARN,
-			"Failed to alloc mem for ld_map_info");
+		cmn_err(CE_WARN, "Failed to alloc mem for ld_map_info");
 		return_raid_msg_pkt(instance, cmd);
 		return (-1);
 	}
 
-	memset(ci, 0, sizeof (*ci));
-	memset(dcmd->mbox.b, 0, DCMD_MBOX_SZ);
+	bzero(ci, sizeof (*ci));
+	bzero(dcmd->mbox.b, DCMD_MBOX_SZ);
 
 	dcmd->cmd = MFI_CMD_OP_DCMD;
 	dcmd->cmd_status = 0xFF;
@@ -2915,11 +2923,9 @@
 
 	if (!instance->func_ptr->issue_cmd_in_poll_mode(instance, cmd)) {
 		ret = 0;
-		con_log(CL_ANN1, (CE_NOTE,
-		    "Get LD Map Info success\n"));
+		con_log(CL_ANN1, (CE_NOTE, "Get LD Map Info success"));
 	} else {
-		cmn_err(CE_WARN,
-		    "Get LD Map Info failed\n");
+		cmn_err(CE_WARN, "Get LD Map Info failed");
 		ret = -1;
 	}
 
@@ -2945,7 +2951,7 @@
 	}
 }
 
-/**
+/*
  * mrsas_tbolt_command_create -	Create command for fast path.
  * @io_info:	MegaRAID IO request packet pointer.
  * @ref_tag:	Reference tag for RD/WRPROTECT
